from quickly.core.commands import BaseCommand, CommandError
import logging
from locale import gettext as _
import os

class Create(BaseCommand):
    
    class Meta:
        name = 'Create'
        icon = 'gtk-new'
        
    def mkdir(self, dirname):
        return os.path.join(os.getcwd(), dirname)
        
    def copy_project_files(self, path):
        pass
        
    def process_project_files(self, path):
        pass
        
    def rename_dir(self, dir_path):
        pass
        
    def rename_file(self, file_path):
        pass
        
    def replace_file_content(self, file_path):
        pass
        
    def init_version_control(self, path):
        pass
        
    def run(self, args):
        if len(args) < 1:
            logging.warn(_('No project name argument'))
            raise CommandError(self, _('Create command requires a project name'))
        logging.info(_("Creating %s project with args: %s" % (self.template._meta.name, args)))
        
        project_name = os.path.basename(args[0])
        logging.info(_('Project name: %s' % project_name))
        
        new_project_path = self.mkdir(args[0])
        logging.info(_('Adding project files to %s' % new_project_path))
        self.copy_project_files(new_project_path)
        self.process_project_files(new_project_path)
        self.init_version_control(new_project_path)

        logging.info(_('Finished creating project'))
